﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="textPDF.aspx.cs" Inherits="textPDF" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title></title>
    <style type="text/css">

.ArticleSubtitle
{
	font: 9pt Verdana, Helvetica;
	color: #cc6633;
	line-height: 18px;
	font-weight:bold;
}

p { text-indent: 0em; margin-top: 0; margin-bottom: 0;margin-left:0 }


.ArticleContent
{
	font: 10pt Verdana, Helvetica;
	color: #333333;
	line-height: 20px;
}
a
{
	color: #555555;
}
.ArticleCode
{
	background-color: #fdffe8;
	font-family: Courier New;
	font-size: 9pt;
	color: #800000;
}
.Gadgets {
	background-image: url('http://www.codedigest.com/App_Themes/CodeDigest/GreyBG.jpg');
	background-repeat: repeat-x;
	font-family: Arial, Helvetica, sans-serif;
	font-size: 12px;
	font-weight: bold;
	color: #324151;
}
.Post
{
	margin-bottom: 8px;
	margin-right: 2px;	
}
.ArtTitle
{
	font: 9pt Verdana, Helvetica;
	margin-top: 4px;
	letter-spacing: -0.5pt;
	font-weight:bold;
}
.ArtTitle a
{
	text-decoration: none;
	color: #475a6d;
}
.PostInfo
{
	border-top: dotted 1px #cccccc;
	margin-top: 6px;
	padding-top: 4px;
	font: 8pt Verdana, Helvetica;
	color: #999999;
}
        .style1
        {
            color: #cc6633;
            line-height: 18px;
            font-style: normal;
            font-variant: normal;
            font-size: 9pt;
            font-family: Verdana, Helvetica;
        }
    </style>
</head>
<body>
    <form id="form1" runat="server">
    <div id="dvText" runat="server">    
                    <p class="ArticleContent">
                        <span lang="EN-IN">At times, we need to fetch some set of XML nodes to populate 
                        an ASP.Net control. The below code will fetch all permanent employees, contract 
                        employees, all employees and populate them to a ddlPermanentEmp, ddlContractEmp, 
                        ddlAllEmployees DropDownList respectively.</span></p>
                    <p class="MsoNormal">
                        &nbsp;</p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">XmlDocument xmldoc = new XmlDocument();</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">xmldoc.Load(Server.MapPath(&quot;~/App_Data/Employees.xml&quot;));
                        </span>
                    </p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">//Get permanent employees</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp; XmlNodeList nodes = 
                        xmldoc.SelectNodes(&quot;/Employees/Employee[@type=&#39;Permanent&#39;]&quot;);</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; foreach (XmlNode 
                        node in nodes)</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; {&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                        </span>
                    </p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 
                        ddlPermanentEmp.Items.Add(new 
                        ListItem(node.SelectSingleNode(&quot;FirstName&quot;).InnerText, 
                        node.SelectSingleNode(&quot;ID&quot;).InnerText));</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; }</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">//Get contract employees</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">nodes = 
                        xmldoc.SelectNodes(&quot;/Employees/Employee[@type=&#39;Contract&#39;]&quot;);</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; foreach (XmlNode 
                        node in nodes)</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; {</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 
                        ddlContractEmp.Items.Add(new 
                        ListItem(node.SelectSingleNode(&quot;FirstName&quot;).InnerText, 
                        node.SelectSingleNode(&quot;ID&quot;).InnerText));</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; }</span></p>
                    <p class="ArticleCode">
                        &nbsp;</p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">//Get all employees</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; nodes = 
                        xmldoc.SelectNodes(&quot;//Employee&quot;);</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; foreach (XmlNode 
                        node in nodes)</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; {</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 
                        ddlAllEmployees.Items.Add(new 
                        ListItem(node.SelectSingleNode(&quot;FirstName&quot;).InnerText, 
                        node.SelectSingleNode(&quot;ID&quot;).InnerText));</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; }</span></p>
                    <p class="MsoNormal">
                        &nbsp;</p>
                    <p class="ArticleContent">
                        <span lang="EN-IN">Thus, with the above examples we have seen some of basic 
                        usages of XPath expressions to query the XML content. </span>
                    </p>
                    <p class="ArticleContent">
                        <span lang="EN-IN">In the coming section, we will see the usages of XPath 
                        related classes in System.Xml.XPath namespace in .NetFramework. </span>
                    </p>
                    <p class="MsoNormal">
                        &nbsp;</p>
                    <p class="style1">
                        <span lang="EN-IN"><b>XPath support in .NetFramework</b></span></p>
                    <p class="ArticleContent">
                        <span lang="EN-IN">The System.Xml.XPath namespace has a class called 
                        XPathNavigator which can be used for both forward and backward navigation of XML 
                        nodes. Technically, it is an abstract class which defines a cursor model for 
                        navigating and editing XML information items as instances of the XPath 2.0 Data 
                        Model. Once after selecting the XML nodes using an XPath expression, it uses 
                        XPathNodeIterator class to iterate through the XML nodes.</span></p>
                    <p class="ArticleContent">
                        <span lang="EN-IN">To create XPathNavigator object, we need to call the 
                        CreateNavigator() method on XmlDocument or XpathDocument object. The below code 
                        will read all permanent employees and load it to a DropDownList ddlEmployees.</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; XPathDocument 
                        xpathdoc = new XPathDocument(Server.MapPath(&quot;~/App_Data/Employees.xml&quot;));</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; XPathNavigator 
                        navigator = xpathdoc.CreateNavigator();</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; XPathExpression 
                        expr = navigator.Compile(&quot;/Employees/Employee[@type=&#39;Permanent&#39;]&quot;);</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; XPathNodeIterator 
                        nodes = navigator.Select(expr);</span></p>
                    <p class="ArticleCode">
                        &nbsp;</p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; while 
                        (nodes.MoveNext())</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; {</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 
                        ddlEmployees.Items.Add(new 
                        ListItem(nodes.Current.SelectSingleNode(&quot;FirstName&quot;).Value, 
                        nodes.Current.SelectSingleNode(&quot;ID&quot;).Value));</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; }</span></p>
              <p class="ArticleContent">
                        <span lang="EN-IN">At times, we need to fetch some set of XML nodes to populate 
                        an ASP.Net control. The below code will fetch all permanent employees, contract 
                        employees, all employees and populate them to a ddlPermanentEmp, ddlContractEmp, 
                        ddlAllEmployees DropDownList respectively.</span></p>
                    <p class="MsoNormal">
                        &nbsp;</p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">XmlDocument xmldoc = new XmlDocument();</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">xmldoc.Load(Server.MapPath(&quot;~/App_Data/Employees.xml&quot;));
                        </span>
                    </p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">//Get permanent employees</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp; XmlNodeList nodes = 
                        xmldoc.SelectNodes(&quot;/Employees/Employee[@type=&#39;Permanent&#39;]&quot;);</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; foreach (XmlNode 
                        node in nodes)</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; {&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                        </span>
                    </p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 
                        ddlPermanentEmp.Items.Add(new 
                        ListItem(node.SelectSingleNode(&quot;FirstName&quot;).InnerText, 
                        node.SelectSingleNode(&quot;ID&quot;).InnerText));</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; }</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">//Get contract employees</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">nodes = 
                        xmldoc.SelectNodes(&quot;/Employees/Employee[@type=&#39;Contract&#39;]&quot;);</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; foreach (XmlNode 
                        node in nodes)</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; {</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 
                        ddlContractEmp.Items.Add(new 
                        ListItem(node.SelectSingleNode(&quot;FirstName&quot;).InnerText, 
                        node.SelectSingleNode(&quot;ID&quot;).InnerText));</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; }</span></p>
                    <p class="ArticleCode">
                        &nbsp;</p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">//Get all employees</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; nodes = 
                        xmldoc.SelectNodes(&quot;//Employee&quot;);</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; foreach (XmlNode 
                        node in nodes)</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; {</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 
                        ddlAllEmployees.Items.Add(new 
                        ListItem(node.SelectSingleNode(&quot;FirstName&quot;).InnerText, 
                        node.SelectSingleNode(&quot;ID&quot;).InnerText));</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; }</span></p>
                    <p class="MsoNormal">
                        &nbsp;</p>
                    <p class="ArticleContent">
                        <span lang="EN-IN">Thus, with the above examples we have seen some of basic 
                        usages of XPath expressions to query the XML content. </span>
                    </p>
                    <p class="ArticleContent">
                        <span lang="EN-IN">In the coming section, we will see the usages of XPath 
                        related classes in System.Xml.XPath namespace in .NetFramework. </span>
                    </p>
                    <p class="MsoNormal">
                        &nbsp;</p>
                    <p class="style1">
                        <span lang="EN-IN"><b>XPath support in .NetFramework</b></span></p>
                    <p class="ArticleContent">
                        <span lang="EN-IN">The System.Xml.XPath namespace has a class called 
                        XPathNavigator which can be used for both forward and backward navigation of XML 
                        nodes. Technically, it is an abstract class which defines a cursor model for 
                        navigating and editing XML information items as instances of the XPath 2.0 Data 
                        Model. Once after selecting the XML nodes using an XPath expression, it uses 
                        XPathNodeIterator class to iterate through the XML nodes.</span></p>
                    <p class="ArticleContent">
                        <span lang="EN-IN">To create XPathNavigator object, we need to call the 
                        CreateNavigator() method on XmlDocument or XpathDocument object. The below code 
                        will read all permanent employees and load it to a DropDownList ddlEmployees.</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; XPathDocument 
                        xpathdoc = new XPathDocument(Server.MapPath(&quot;~/App_Data/Employees.xml&quot;));</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; XPathNavigator 
                        navigator = xpathdoc.CreateNavigator();</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; XPathExpression 
                        expr = navigator.Compile(&quot;/Employees/Employee[@type=&#39;Permanent&#39;]&quot;);</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; XPathNodeIterator 
                        nodes = navigator.Select(expr);</span></p>
                    <p class="ArticleCode">
                        &nbsp;</p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; while 
                        (nodes.MoveNext())</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; {</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 
                        ddlEmployees.Items.Add(new 
                        ListItem(nodes.Current.SelectSingleNode(&quot;FirstName&quot;).Value, 
                        nodes.Current.SelectSingleNode(&quot;ID&quot;).Value));</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; }</span></p>
              <p class="ArticleContent">
                        <span lang="EN-IN">At times, we need to fetch some set of XML nodes to populate 
                        an ASP.Net control. The below code will fetch all permanent employees, contract 
                        employees, all employees and populate them to a ddlPermanentEmp, ddlContractEmp, 
                        ddlAllEmployees DropDownList respectively.</span></p>
                    <p class="MsoNormal">
                        &nbsp;</p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">XmlDocument xmldoc = new XmlDocument();</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">xmldoc.Load(Server.MapPath(&quot;~/App_Data/Employees.xml&quot;));
                        </span>
                    </p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">//Get permanent employees</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp; XmlNodeList nodes = 
                        xmldoc.SelectNodes(&quot;/Employees/Employee[@type=&#39;Permanent&#39;]&quot;);</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; foreach (XmlNode 
                        node in nodes)</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; {&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                        </span>
                    </p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 
                        ddlPermanentEmp.Items.Add(new 
                        ListItem(node.SelectSingleNode(&quot;FirstName&quot;).InnerText, 
                        node.SelectSingleNode(&quot;ID&quot;).InnerText));</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; }</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">//Get contract employees</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">nodes = 
                        xmldoc.SelectNodes(&quot;/Employees/Employee[@type=&#39;Contract&#39;]&quot;);</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; foreach (XmlNode 
                        node in nodes)</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; {</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 
                        ddlContractEmp.Items.Add(new 
                        ListItem(node.SelectSingleNode(&quot;FirstName&quot;).InnerText, 
                        node.SelectSingleNode(&quot;ID&quot;).InnerText));</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; }</span></p>
                    <p class="ArticleCode">
                        &nbsp;</p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">//Get all employees</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; nodes = 
                        xmldoc.SelectNodes(&quot;//Employee&quot;);</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; foreach (XmlNode 
                        node in nodes)</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; {</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 
                        ddlAllEmployees.Items.Add(new 
                        ListItem(node.SelectSingleNode(&quot;FirstName&quot;).InnerText, 
                        node.SelectSingleNode(&quot;ID&quot;).InnerText));</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; }</span></p>
                    <p class="MsoNormal">
                        &nbsp;</p>
                    <p class="ArticleContent">
                        <span lang="EN-IN">Thus, with the above examples we have seen some of basic 
                        usages of XPath expressions to query the XML content. </span>
                    </p>
                    <p class="ArticleContent">
                        <span lang="EN-IN">In the coming section, we will see the usages of XPath 
                        related classes in System.Xml.XPath namespace in .NetFramework. </span>
                    </p>
                    <p class="MsoNormal">
                        &nbsp;</p>
                    <p class="style1">
                        <span lang="EN-IN"><b>XPath support in .NetFramework</b></span></p>
                    <p class="ArticleContent">
                        <span lang="EN-IN">The System.Xml.XPath namespace has a class called 
                        XPathNavigator which can be used for both forward and backward navigation of XML 
                        nodes. Technically, it is an abstract class which defines a cursor model for 
                        navigating and editing XML information items as instances of the XPath 2.0 Data 
                        Model. Once after selecting the XML nodes using an XPath expression, it uses 
                        XPathNodeIterator class to iterate through the XML nodes.</span></p>
                    <p class="ArticleContent">
                        <span lang="EN-IN">To create XPathNavigator object, we need to call the 
                        CreateNavigator() method on XmlDocument or XpathDocument object. The below code 
                        will read all permanent employees and load it to a DropDownList ddlEmployees.</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; XPathDocument 
                        xpathdoc = new XPathDocument(Server.MapPath(&quot;~/App_Data/Employees.xml&quot;));</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; XPathNavigator 
                        navigator = xpathdoc.CreateNavigator();</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; XPathExpression 
                        expr = navigator.Compile(&quot;/Employees/Employee[@type=&#39;Permanent&#39;]&quot;);</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; XPathNodeIterator 
                        nodes = navigator.Select(expr);</span></p>
                    <p class="ArticleCode">
                        &nbsp;</p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; while 
                        (nodes.MoveNext())</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; {</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 
                        ddlEmployees.Items.Add(new 
                        ListItem(nodes.Current.SelectSingleNode(&quot;FirstName&quot;).Value, 
                        nodes.Current.SelectSingleNode(&quot;ID&quot;).Value));</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; }</span></p>
              <p class="ArticleContent">
                        <span lang="EN-IN">At times, we need to fetch some set of XML nodes to populate 
                        an ASP.Net control. The below code will fetch all permanent employees, contract 
                        employees, all employees and populate them to a ddlPermanentEmp, ddlContractEmp, 
                        ddlAllEmployees DropDownList respectively.</span></p>
                    <p class="MsoNormal">
                        &nbsp;</p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">XmlDocument xmldoc = new XmlDocument();</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">xmldoc.Load(Server.MapPath(&quot;~/App_Data/Employees.xml&quot;));
                        </span>
                    </p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">//Get permanent employees</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp; XmlNodeList nodes = 
                        xmldoc.SelectNodes(&quot;/Employees/Employee[@type=&#39;Permanent&#39;]&quot;);</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; foreach (XmlNode 
                        node in nodes)</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; {&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                        </span>
                    </p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 
                        ddlPermanentEmp.Items.Add(new 
                        ListItem(node.SelectSingleNode(&quot;FirstName&quot;).InnerText, 
                        node.SelectSingleNode(&quot;ID&quot;).InnerText));</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; }</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">//Get contract employees</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">nodes = 
                        xmldoc.SelectNodes(&quot;/Employees/Employee[@type=&#39;Contract&#39;]&quot;);</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; foreach (XmlNode 
                        node in nodes)</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; {</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 
                        ddlContractEmp.Items.Add(new 
                        ListItem(node.SelectSingleNode(&quot;FirstName&quot;).InnerText, 
                        node.SelectSingleNode(&quot;ID&quot;).InnerText));</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; }</span></p>
                    <p class="ArticleCode">
                        &nbsp;</p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">//Get all employees</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; nodes = 
                        xmldoc.SelectNodes(&quot;//Employee&quot;);</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; foreach (XmlNode 
                        node in nodes)</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; {</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 
                        ddlAllEmployees.Items.Add(new 
                        ListItem(node.SelectSingleNode(&quot;FirstName&quot;).InnerText, 
                        node.SelectSingleNode(&quot;ID&quot;).InnerText));</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; }</span></p>
                    <p class="MsoNormal">
                        &nbsp;</p>
                    <p class="ArticleContent">
                        <span lang="EN-IN">Thus, with the above examples we have seen some of basic 
                        usages of XPath expressions to query the XML content. </span>
                    </p>
                    <p class="ArticleContent">
                        <span lang="EN-IN">In the coming section, we will see the usages of XPath 
                        related classes in System.Xml.XPath namespace in .NetFramework. </span>
                    </p>
                    <p class="MsoNormal">
                        &nbsp;</p>
                    <p class="style1">
                        <span lang="EN-IN"><b>XPath support in .NetFramework</b></span></p>
                    <p class="ArticleContent">
                        <span lang="EN-IN">The System.Xml.XPath namespace has a class called 
                        XPathNavigator which can be used for both forward and backward navigation of XML 
                        nodes. Technically, it is an abstract class which defines a cursor model for 
                        navigating and editing XML information items as instances of the XPath 2.0 Data 
                        Model. Once after selecting the XML nodes using an XPath expression, it uses 
                        XPathNodeIterator class to iterate through the XML nodes.</span></p>
                    <p class="ArticleContent">
                        <span lang="EN-IN">To create XPathNavigator object, we need to call the 
                        CreateNavigator() method on XmlDocument or XpathDocument object. The below code 
                        will read all permanent employees and load it to a DropDownList ddlEmployees.</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; XPathDocument 
                        xpathdoc = new XPathDocument(Server.MapPath(&quot;~/App_Data/Employees.xml&quot;));</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; XPathNavigator 
                        navigator = xpathdoc.CreateNavigator();</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; XPathExpression 
                        expr = navigator.Compile(&quot;/Employees/Employee[@type=&#39;Permanent&#39;]&quot;);</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; XPathNodeIterator 
                        nodes = navigator.Select(expr);</span></p>
                    <p class="ArticleCode">
                        &nbsp;</p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; while 
                        (nodes.MoveNext())</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; {</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 
                        ddlEmployees.Items.Add(new 
                        ListItem(nodes.Current.SelectSingleNode(&quot;FirstName&quot;).Value, 
                        nodes.Current.SelectSingleNode(&quot;ID&quot;).Value));</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; }</span></p>
              <p class="ArticleContent">
                        <span lang="EN-IN">At times, we need to fetch some set of XML nodes to populate 
                        an ASP.Net control. The below code will fetch all permanent employees, contract 
                        employees, all employees and populate them to a ddlPermanentEmp, ddlContractEmp, 
                        ddlAllEmployees DropDownList respectively.</span></p>
                    <p class="MsoNormal">
                        &nbsp;</p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">XmlDocument xmldoc = new XmlDocument();</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">xmldoc.Load(Server.MapPath(&quot;~/App_Data/Employees.xml&quot;));
                        </span>
                    </p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">//Get permanent employees</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp; XmlNodeList nodes = 
                        xmldoc.SelectNodes(&quot;/Employees/Employee[@type=&#39;Permanent&#39;]&quot;);</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; foreach (XmlNode 
                        node in nodes)</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; {&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                        </span>
                    </p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 
                        ddlPermanentEmp.Items.Add(new 
                        ListItem(node.SelectSingleNode(&quot;FirstName&quot;).InnerText, 
                        node.SelectSingleNode(&quot;ID&quot;).InnerText));</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; }</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">//Get contract employees</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">nodes = 
                        xmldoc.SelectNodes(&quot;/Employees/Employee[@type=&#39;Contract&#39;]&quot;);</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; foreach (XmlNode 
                        node in nodes)</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; {</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 
                        ddlContractEmp.Items.Add(new 
                        ListItem(node.SelectSingleNode(&quot;FirstName&quot;).InnerText, 
                        node.SelectSingleNode(&quot;ID&quot;).InnerText));</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; }</span></p>
                    <p class="ArticleCode">
                        &nbsp;</p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">//Get all employees</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; nodes = 
                        xmldoc.SelectNodes(&quot;//Employee&quot;);</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; foreach (XmlNode 
                        node in nodes)</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; {</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 
                        ddlAllEmployees.Items.Add(new 
                        ListItem(node.SelectSingleNode(&quot;FirstName&quot;).InnerText, 
                        node.SelectSingleNode(&quot;ID&quot;).InnerText));</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; }</span></p>
                    <p class="MsoNormal">
                        &nbsp;</p>
                    <p class="ArticleContent">
                        <span lang="EN-IN">Thus, with the above examples we have seen some of basic 
                        usages of XPath expressions to query the XML content. </span>
                    </p>
                    <p class="ArticleContent">
                        <span lang="EN-IN">In the coming section, we will see the usages of XPath 
                        related classes in System.Xml.XPath namespace in .NetFramework. </span>
                    </p>
                    <p class="MsoNormal">
                        &nbsp;</p>
                    <p class="style1">
                        <span lang="EN-IN"><b>XPath support in .NetFramework</b></span></p>
                    <p class="ArticleContent">
                        <span lang="EN-IN">The System.Xml.XPath namespace has a class called 
                        XPathNavigator which can be used for both forward and backward navigation of XML 
                        nodes. Technically, it is an abstract class which defines a cursor model for 
                        navigating and editing XML information items as instances of the XPath 2.0 Data 
                        Model. Once after selecting the XML nodes using an XPath expression, it uses 
                        XPathNodeIterator class to iterate through the XML nodes.</span></p>
                    <p class="ArticleContent">
                        <span lang="EN-IN">To create XPathNavigator object, we need to call the 
                        CreateNavigator() method on XmlDocument or XpathDocument object. The below code 
                        will read all permanent employees and load it to a DropDownList ddlEmployees.</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; XPathDocument 
                        xpathdoc = new XPathDocument(Server.MapPath(&quot;~/App_Data/Employees.xml&quot;));</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; XPathNavigator 
                        navigator = xpathdoc.CreateNavigator();</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; XPathExpression 
                        expr = navigator.Compile(&quot;/Employees/Employee[@type=&#39;Permanent&#39;]&quot;);</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; XPathNodeIterator 
                        nodes = navigator.Select(expr);</span></p>
                    <p class="ArticleCode">
                        &nbsp;</p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; while 
                        (nodes.MoveNext())</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; {</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 
                        ddlEmployees.Items.Add(new 
                        ListItem(nodes.Current.SelectSingleNode(&quot;FirstName&quot;).Value, 
                        nodes.Current.SelectSingleNode(&quot;ID&quot;).Value));</span></p>
                    <p class="ArticleCode">
                        <span lang="EN-IN">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; }</span></p>
              
    </div>
    <asp:Button ID="btnExport" runat="server" Text="Export to Excel" 
        onclick="btnExport_Click" />
    </form>
    
</body>
</html>
